Test (temporarily) retired - refer to comment in test script.
[xfstests-dev.git] / 030
1 #! /bin/sh
2 # XFS QA Test No. 030
3 # $Id: 1.3 $
4 #
5 # exercise xfs_repair repairing broken filesystems
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2000 Silicon Graphics, Inc.  All Rights Reserved.
9
10 # This program is free software; you can redistribute it and/or modify it
11 # under the terms of version 2 of the GNU General Public License as
12 # published by the Free Software Foundation.
13
14 # This program is distributed in the hope that it would be useful, but
15 # WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
17
18 # Further, this software is distributed without any warranty that it is
19 # free of the rightful claim of any third person regarding infringement
20 # or the like.  Any license provided herein, whether implied or
21 # otherwise, applies only to this software file.  Patent licenses, if
22 # any, provided herein do not apply to combinations of this program with
23 # other software, or any other product whatsoever.
24
25 # You should have received a copy of the GNU General Public License along
26 # with this program; if not, write the Free Software Foundation, Inc., 59
27 # Temple Place - Suite 330, Boston MA 02111-1307, USA.
28
29 # Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
30 # Mountain View, CA  94043, or:
31
32 # http://www.sgi.com 
33
34 # For further information regarding this notice, see: 
35
36 # http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
37 #-----------------------------------------------------------------------
38 #
39 # creator
40 owner=nathans@sgi.com
41
42 seq=`basename $0`
43 echo "QA output created by $seq"
44
45 here=`pwd`
46 tmp=/tmp/$$
47 status=1        # failure is the default!
48
49 _cleanup()
50 {
51         umount $SCRATCH_DEV 2>/dev/null
52         rm -f $tmp.*
53 }
54
55 trap "_cleanup; exit \$status" 0 1 2 3 15
56
57 # get standard environment, filters and checks
58 . ./common.rc
59 . ./common.filter
60 . ./common.repair
61
62 # nuke the superblock, AGI, AGF, AGFL; then try repair the damage
63
64 _check_ag()
65 {
66         for structure in 'sb 0' 'agf 0' 'agi 0' 'agfl 0'
67         do
68                 echo "Corrupting $structure - setting bits to $1"
69                 _check_repair $1 "$structure"
70         done
71 }
72
73 # real QA test starts here
74 _require_scratch
75
76 # first we need to ensure there are no bogus secondary
77 # superblocks between the primary and first secondary
78 # superblock (hanging around from earlier tests)...
79
80 size="-d size=100m"
81 mkfs -t xfs -f $size $SCRATCH_DEV >/dev/null 2>&1
82 if [ $? -ne 0 ]         # probably don't have a big enough scratch
83 then
84         _notrun "SCRATCH_DEV too small, results would be non-deterministic"
85 else
86         mount -t xfs $SCRATCH_DEV $SCRATCH_MNT
87         src/feature -U $SCRATCH_DEV && \
88                 _notrun "Quota are enabled, test needs controlled sb recovery"
89         src/feature -G $SCRATCH_DEV && \
90                 _notrun "Quota are enabled, test needs controlled sb recovery"
91         umount $SCRATCH_DEV
92 fi
93 clear=""
94 eval `xfs_db -r -c "sb 1" -c stack $SCRATCH_DEV | perl -ne '
95         if (/byte offset (\d+), length (\d+)/) {
96                 print "clear=", $1 / 512, "\n"; exit
97         }'`
98 [ -z "$clear" ] && echo "Cannot calculate length to clear"
99 src/devzero -v -1 -n "$clear" $SCRATCH_DEV >/dev/null
100
101 # now kick off the real repair test...
102
103 mkfs -t xfs -f $size $SCRATCH_DEV | _filter_mkfs 2>$tmp.mkfs
104 source $tmp.mkfs
105 _check_ag 0
106 _check_ag -1
107
108
109 # success, all done
110 status=0
111 exit